summaryrefslogtreecommitdiff
path: root/devtools
diff options
context:
space:
mode:
authorThomas Monjalon <thomas@monjalon.net>2018-05-27 23:54:47 +0200
committerThomas Monjalon <thomas@monjalon.net>2018-05-29 17:43:33 +0200
commitf8ad40dc998cfaa5b08d97d813570ec6373dabcc (patch)
treee4b25cb7f96e8003b854a1eb7772fcbcc5e8efce /devtools
parenta55277a788dfba015602cf0a56a6e584b5b2ec7d (diff)
downloaddpdk-next-eventdev-f8ad40dc998cfaa5b08d97d813570ec6373dabcc.zip
dpdk-next-eventdev-f8ad40dc998cfaa5b08d97d813570ec6373dabcc.tar.gz
dpdk-next-eventdev-f8ad40dc998cfaa5b08d97d813570ec6373dabcc.tar.xz
devtools: check orphan symbols in map files
The script check-symbol-maps.sh finds the symbols exported in a map file but not referenced in the codebase. Suggested-by: Pavan Nikhilesh <pbhagavatula@caviumnetworks.com> Signed-off-by: Thomas Monjalon <thomas@monjalon.net>
Diffstat (limited to 'devtools')
-rwxr-xr-xdevtools/check-symbol-maps.sh30
1 files changed, 30 insertions, 0 deletions
diff --git a/devtools/check-symbol-maps.sh b/devtools/check-symbol-maps.sh
new file mode 100755
index 0000000..e137d48
--- /dev/null
+++ b/devtools/check-symbol-maps.sh
@@ -0,0 +1,30 @@
+#! /bin/sh -e
+# SPDX-License-Identifier: BSD-3-Clause
+# Copyright 2018 Mellanox Technologies, Ltd
+
+cd $(dirname $0)/..
+
+# speed up by ignoring Unicode details
+export LC_ALL=C
+
+find_orphan_symbols ()
+{
+ for map in $(find lib drivers -name '*.map') ; do
+ for sym in $(sed -rn 's,^([^}]*_.*);,\1,p' $map) ; do
+ if echo $sym | grep -q '^per_lcore_' ; then
+ continue
+ fi
+ if ! grep -q -r --exclude=$(basename $map) \
+ -w $sym $(dirname $map) ; then
+ echo "$map: $sym"
+ fi
+ done
+ done
+}
+
+orphan_symbols=$(find_orphan_symbols)
+if [ -n "$orphan_symbols" ] ; then
+ echo "Found only in symbol map file:"
+ echo "$orphan_symbols" | sed 's,^,\t,'
+ exit 1
+fi